module Main where

--------------------------------------------------------------------------------

import           Calculator.Evaluator.Base     (evaluate)
import           Calculator.Prim.Expr          (Bindings, def_vars)

--------------------------------------------------------------------------------

import           System.Console.Haskeline

--------------------------------------------------------------------------------

type Repl a = InputT IO a

--------------------------------------------------------------------------------

repl :: Bindings -> Repl ()
repl b = do
  input <- getInputLine "calc> "
  case input of
   Nothing  -> return ()
   Just inp -> let result = evaluate b inp
               in case result of
                   Left s   -> outputStrLn s >> repl b
                   Right b' -> repl b'

--------------------------------------------------------------------------------

main :: IO ()
main = runInputT defaultSettings (repl def_vars)

--------------------------------------------------------------------------------
